.\" $NetBSD: wsmux.4,v 1.10 2002/10/25 21:00:45 wiz Exp $
.\"
.\" Copyright (c) 1999 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd July 26, 1999
.Dt WSMUX 4
.Os
.Sh NAME
.Nm wsmux
.Nd console keyboard/mouse multiplexor for wscons
.Sh SYNOPSIS
.Cd "wskbd*   at ... mux 1"
.Cd "wsmouse* at ... mux 0"
.Pp
.Cd pseudo-device wsmux
.Sh DESCRIPTION
The
.Nm
is a pseudo-device driver that allows several
.Xr wscons 4
input devices to have their events multiplexed into one stream.
.Pp
The typical usage for this device is to have two multiplexors, one
for mouse events and one for keyboard events.  All
.Xr wsmouse 4
devices should direct their events to the mouse mux (normally 0)
and all keyboard devices, except the console, should direct their
events to the keyboard mux (normally 1).  A device will
send its events to the mux indicated by the
.Va mux
locator.  If none is given the device will not use a multiplexor.
The keyboard multiplexor should be connected to the display, using
the
.Xr wsconscfg 8
command.  It will then receive all keystrokes from all keyboards
and, furthermore, keyboards can be dynamically attached and detached without
further user interaction.
In a similar way, the window system will open the mouse multiplexor
and receive all mouse events; mice can also be dynamically attached
and detached.
.Pp
If a
.Xr wskbd 4
or
.Xr wsmouse 4
device is opened despite having a mux it will be detached from the mux.
.Pp
It is also possible to inject events into a multiplexor from a
user program.
.\" This is used by the
.\" .Xr moused 8
.\" daemon to take data from a mouse connected to a serial port and
.\" make it appear on the standard mouse mux.
.Sh FILES
For each mux device,
.Pa /dev/wsmuxN
there is a control device
.Pa /dev/wsmuxctlN .
The control device has a minor number 128 greater than the regular
mux device.  It can be used to control the mux even when it is open,
e.g., by
.Xr wsmuxctl 8 .
.Bl -item
.It
.Pa /dev/wsmouse
a.k.a.
.Pa /dev/wsmux0
.It
.Pa /dev/wskbd
a.k.a.
.Pa /dev/wsmux1
.It
.Pa /usr/include/dev/wscons/wsconsio.h
.El
.Sh SEE ALSO
.Xr wscons 4 ,
.Xr wsdisplay 4 ,
.Xr wskbd 4 ,
.Xr wsmouse 4 ,
.Xr moused 8 ,
.Xr wsconscfg 8 ,
.Xr wsconsctl 8 ,
.Xr wsfontload 8 ,
.Xr wsmoused 8 ,
.Xr wsmuxctl 8
